asynets

Une bibliothèque Asymptote pour dessiner des réseaux d'interaction.


* Installation

Un:

    tar xjf asynets-*.tar.bz2

devrait suffire.

Testé avec la version 1.33 d'Asymptote.


* Structure de la distribution 

Le cœur est constitué des modules 'common', 'render', 'type', 'link' et 'cell':
	common.asy:
		quelques variables globales
   	render.asy:
		définition du type 'render', qui permet d'unifier tout ce qui
		peut être rendu dans un dessin
	type.asy:
	    définition du type 'type', qui comprend principalement
		une étiquette et l'indication d'une orientation
    link.asy:
		définition du type 'link', qui comprend principalement
	    un chemin et une liste de types
    cell.asy:
		définition du type 'cell', qui comprend principalement
	    un dessin et une liste de ports (de type 'link')

On a ensuite quelques modules plus spécialisés: 
	rectcell.asy:
		fournit de quoi créer des cellules rectangulaires, à coins
		arrondis
	tricell.asy:
		fournit de quoi créer des cellules triangulaires: les coins de
		la base sont arrondis, en contraste avec la pointe qui
		correspond au port principal
	boxes.asy:
		hack immonde pour faire rentrer les boîtes dans le type 'cell'
	reductions.asy:
		module un peu à part, utilisé principalement pour générer les
		dessins du redex et du réduit d'une même réduction à partir d'un
		seul fichier source
	tests.asy:
		permet de créer puis lancer une batterie de tests

Enfin, les modules suivants réunissent tout ça: 
	diffnets.asy:
		permet de créer des cellules de réseaux diff, des réseaux
		génériques (blobs), et des boîtes aux dimensions automatisées
	commzone.asy:
		permet de générer des zones de communication à la
		Ehrhard-Laurent


* Remarques

Tout ça est codé avec les pieds, non documenté, et n'a fait ses preuves
que pour un seul et unique utilisateur jusqu'ici. Des exemples (fichiers
'exemple_*.asy') peuvent donner une idée de comment tout ça fonctionne.
Les fichiers sources sont également parsemés de fonctions de test (de la
forme 'void test_machin(picture)'), originellement introduites à des fins de
débuggage: le code en est généralement assez court et basique.

On peut lancer la suite de tous les tests disponibles, comme dans la
session Asymptote suivante:

	$ asy 
	Welcome to Asymptote version 1.33 (to view the manual, type help)
	> import diffnets
	> runtests()

Chaque test est alors lancé, avec une sortie du genre:

	Running test: test_link
	├-> Tags: [link] [test_link].
	├-> Clean picture.
	├-> Draw.
	├-> Ship out.
	└-> Next ? (Y/n)

Sur la première ligne se trouve le nom du test: un grep sur les sources
permet d'en trouver le code. On peut également restreindre les tests à
certains tags: runtest("box") ne lancera que les tests concernant les
boîtes.


* Copyright et license

Le paquet asynets est écrit et mal maintenu par Lionel Vaux
<vaux@iml.univ-mrs.fr>. Il est distribué selon les termes de la WTFPL
de Sam Hocevar, version 2 ou supérieure: voir http://sam.zoy.org/wtfpl/.

Toute remarque, critique ou suggestion est la bienvenue, afin de rendre
ce programme utile ou au moins utilisable.

~ vim: set tw=72 sw=4 ts=4:
