import cell ;

access settings ;

string redexprefix(string prefix=settings.outname) {
	if (find(prefix,"asy=red=")==0)
		return "asy=redex="+substr(prefix,8) ;
	else
		return prefix+"_redex" ; 
}
string reductprefix(string prefix=settings.outname) {
	if (find(prefix,"asy=red=")==0)
		return "asy=reduct="+substr(prefix,8) ;
	else
		return prefix+"_reduct" ; 
}

/**************************************
 *                                    * 
 *             Reductions             * 
 *                                    * 
 **************************************/

/* Reduction data */

picture lhs ;
void lhs(... render[] rs) {
	picture pic ;
	render(pic ... rs) ;
	lhs = pic ;
}

void cutlhs(cell l, cell r) {
	cut(l,r) ;
	lhs(l,r) ;
}

picture rhs ;
void rhs(... render[] rs) {
	picture pic ;
	render(pic ... rs) ;
	rhs = pic ;
}

/* Interface management */

typedef link interface[] ;

interface interface (... link [] ps) {
	return map(copy,ps) ; 
}

interface reverse(interface i) {
	return map(reverse,i) ; 
}

void extend (interface interface ... link [] ls  ) {
	for (int i = 0 ; i < ls.length ; ++i) 
		merge (ls[i], interface[i]) ;
}

/* Draw reductions */

Label redsym = "$\rightarrow$" ;


picture lcralign(picture lhs, Label L, picture rhs) {
	picture pic ;
 	label(pic,L,(0,0)) ;
 	pair ldim = max(lhs.userMax-lhs.userMin) ;
 	pair rdim = max(rhs.userMax-rhs.userMin) ;
 	real w = max(ldim.x,rdim.x) ;
 //	dot(pic,(1+w)*W,invisible);
 //	dot(pic,(1+w)*E,invisible);
 	add(pic,shift(W*(lhs.userMax.x+.5))*lhs) ;
 	add(pic,shift(E*(-rhs.userMin.x+.5))*rhs) ;
	return pic ;
}

void reduction(string prefix=settings.outname,
		picture lhs=lhs, picture rhs=rhs, real xmargin=0, real ymargin=0) {
		erase() ;
		bbox(lhs,xmargin=xmargin,ymargin=ymargin,invisible) ;
		add(lhs) ;
		shipout(prefix=redexprefix(prefix));
		erase() ;
		bbox(rhs,xmargin=xmargin,ymargin=ymargin,invisible) ;
		add(rhs) ;
		shipout(prefix=reductprefix(prefix));
}

