/**************************************
 *                                    * 
 *             Render                 * 
 *                                    * 
 **************************************/

/* Basic render structure */

struct render {
	void render(picture pic=currentpicture) ;
}

render operator init () { return new render ; }

render render (void f (picture)) {
	render r ; 
	r.render = f ;
	return r ; 
}

/* Default casts */

render operator cast (picture pic) { 
	return render(new void (picture p) { add(p,pic) ; }) ;
}

render operator cast (Label L) { 
	return render(new void (picture pic) { label(pic,L) ;}) ;
}

render operator cast (path g) { 
	return render(new void (picture pic) { draw(pic,g) ;}) ;
}

render operator cast (guide g) { 
	return (render)(path)g ;
}

/* Rendering functions  */ 

void render (explicit picture pic=currentpicture ... render[]rs) {
	for (int i=0; i<rs.length; ++i) {
		render r=rs[i] ;
		r.render(pic) ;
	}
}

picture picture (... render[]rs) {
	picture p ; 
	render (p ... rs) ; 
	return p ; 
}


