typedef void unittest(picture pic) ;

struct test {
	string s;
	string q [];
	unittest f ;
}

test test(string s, unittest f, string q[]) {
	test t = new test ;
	t.s=s ;
	t.f=f ;
	t.q=q ;
	return t ;
}

test test(string s, unittest f ... string [] q) {
	return test(s,f,q) ;
}

test knowntests [] = new test [] ;

void addtest (test tests[]=knowntests, string s, unittest f 
		... string [] q) {
	q.push(s) ;
	tests.push(test(s,f,q)) ;
}

bool allmem(string keys[], string q[]) {
	bool res = true ;
	for (int key=0; key<keys.length; ++key) {
		bool neq[]=(q!=keys[key]) ;
		res = res && (!all(neq)) ; 
	}
	return res ;
}

bool runtest (test test, picture pic=currentpicture ... string [] q) {
	if (allmem(q,test.q)) {
		write("Running test: "+test.s) ;
		string tags="";
		for (int i=0;i<test.q.length;++i) tags=tags+" ["+test.q[i]+"]";
		write("├-> Tags:"+tags+".") ;
		write("├-> Clean picture.") ;
		erase(pic) ; 
		unitsize(pic,1cm) ; 
		write("├-> Draw.") ;
		test.f(pic) ; 
		write("├-> Ship out.") ;
		shipout(pic) ;
		string ret=getstring(prompt="└-> Next ? (Y/n)",
				default="Y",store=false,name="noname") ; 
		write(ret) ;
		if (ret=="Y" || ret=="y" || ret=="") 
			return true ;
		else 
			return false ;
	} else {
		write("Not running test: "+test.s) ;
		return true ;
	}
}


bool runtests (test tests[]=knowntests, picture pic=currentpicture 
		... string [] q) {
	bool res = true ; 
	int i=0 ;
	while (res && i<tests.length) {
		res = runtest(tests[i],pic ... q) ;
		++i ; 
	}
	return res ;
}

